Subject: Should the byte compiler warn about :type mismatches?

From: Alex Branham <[email-masked]>
Date: Thu, 29 Mar 2018 11:55:07 -0500

severity: wishlist

Would it be possible/desirable to make the byte-compiler warn about
:type mismatches with defcustoms? I've noticed that the default values
for quite a few packages I use (both in Emacs [Bug#30901 for example]
and not) do not match. Presumably this would be easier to catch if the
compiler warned about it.

In case I'm not being clear, writing something like this:

(defcustom my-var t
  "Docs."
  :group 'text
  :type 'string)

Would result in a warning during byte compilation along the lines of:

"Warning: Default value for 'my-var' does not match :type".